/***
 * Excerpted from "Resourceful Code Reuse",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/dzreuse for more book information.
***/
#include <stdio.h> 
#include <stdlib.h>  // For EXIT_SUCCESS or EXIT_FAILURE
#include <dlfcn.h> // for the dl* functions
#include "json.h"

int main() {
  // Open the handle
  void *json_lib = dlopen("./libmyjson.so", RTLD_LAZY); 
  if (!json_lib) {
    fprintf(stderr, "%s\n", dlerror()); // perror() does not work!
    return EXIT_FAILURE;
  }

  // Find a symbol
  dlerror(); 
  void *json_reader = dlsym(json_lib, "read_json");
  char *possible_error = dlerror();
  
  if (possible_error) {
    fprintf(stderr, "%s\n", possible_error);
    return EXIT_FAILURE;
  }

  // Call the function
  typedef JSON_Object* (*Reader_Func)(char *);  
  JSON_Object *retval = ((Reader_Func)json_reader)("somefile.json");
  puts((char *)retval);
  
  // Close the handle
  if(dlclose(json_lib)) 
    fprintf(stderr, "%s, but who cares?\n", dlerror());     

  return EXIT_SUCCESS;
}
