/***
 * Excerpted from "Resourceful Code Reuse",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/dzreuse for more book information.
***/
// client program to test remote JSON service 
#include <stdio.h>
#include <stdlib.h>
#include <rpc/rpc.h>
#include "json.h"

int main(int argc, char *argv[])
{
  if (argc != 2) {
    fprintf(stderr, "USAGE: %s hostname\n", argv[0]);
    return EXIT_FAILURE;
  }

  CLIENT *cl = clnt_create(argv[1], JSONPROG, JSONVERS, "udp"); 
  if (!cl) {
    // couldn't establish connection with server
    fprintf(stderr, "can't establish connection with host %s\n", argv[1]);
    return EXIT_FAILURE;
  }
  
  // first call the remote procedure read_json()
  char *fullpath = "somefile.json:2:bar:11";
  char **result = read_json_item_1(&fullpath, cl); 
  if (!result) {
    clnt_perror(cl, "read_json");
    return EXIT_FAILURE;
  }
  
  printf("%s\n", *result);
  // prints 2:bar:11 <label id="rpctest.print"/>
  
  clnt_destroy(cl); // done with the handle <label id="rpctest.destroy"/>
  return EXIT_SUCCESS;
}
